#property copyright "Copyright 2014, Mimi"
#property link      ""
#property version   "1.00"


extern double LotSize = 0.1;
extern double StopLoss = 10;
extern double TakeProfit = 20;

extern int Slippage = 5;
extern int MagicNumber = 123;


double   currentlow;
double   currenthigh;

double S1;


double lowest;
double highest;

double ES;
double EB;

double R1;

datetime D = Day();
int q;
int BuyTicket = 0;
int SellTicket = 0;
double UsePoint;
int UseSlippage;


// Init function
int init()
{
UsePoint = PipPoint(Symbol());
UseSlippage = GetSlippage(Symbol(),Slippage);
return(UsePoint);
return(UseSlippage);
}
// Start function
int start()
{

for( q=0;q<OrdersTotal();q++)
 {
  if (OrderSelect(q, SELECT_BY_POS, MODE_TRADES)==true && OrderSymbol()==Symbol())
   {
// checking positions for open orders.
   if (OrderType()==OP_BUYSTOP)
     {
      
       return(0); 
     }
     
   if (OrderType () == OP_BUYLIMIT)
   {
   return(0);
   }
   
   if (OrderType () == OP_SELLLIMIT)
   {
   return(0);
   }  
   if (OrderType()==OP_SELLSTOP)
     {
      
       return(0); 
     }
     
   }  
}
int Ticket = BuyTicket + SellTicket;
double CP = Bid;
lowest = Low[iLowest(NULL,PERIOD_D1,MODE_LOW,1,1)];
highest = High[iHighest(NULL,PERIOD_D1,MODE_HIGH,1,1)];

if( (highest - CP) > (20 * Point))
{
if(Ticket < 20)
{
currenthigh = highest;

//---Calculating Support


S1 = highest - (40 * Point);
// Buy order

OrderSelect(BuyTicket,SELECT_BY_TICKET);

// Delete Order
 if(OrderCloseTime() == 0 && BuyTicket > 0 && OrderType() == OP_BUYLIMIT)
{
bool Deleted = OrderDelete(BuyTicket,Green);
}

else if( Bid > highest)
{
Deleted = OrderDelete(BuyTicket,Green);
}


// Calculate stop loss and take profit
if(StopLoss > 0) double BuyStopLoss = S1 - (StopLoss * Point);
if(TakeProfit > 0) double BuyTakeProfit = S1 + (TakeProfit * Point);

// Open buy order
EB = MathAbs((S1 - Bid));

if (Bid < S1 && EB > (20 * Point))
{ 
BuyTicket = OrderSend(Symbol(),OP_BUYSTOP,LotSize,S1,UseSlippage,BuyStopLoss,BuyTakeProfit,"Buy Stop Order",MagicNumber,D+1,Green);
SellTicket = 0;
}
else if(Bid > S1 && EB > (20 * Point))
{
BuyTicket = OrderSend(Symbol(),OP_BUYLIMIT,LotSize,S1,UseSlippage,BuyStopLoss,BuyTakeProfit,"Buy Limit Order",MagicNumber,D+1,Green);
SellTicket = 0;
}
// Sell Order
}
}
else if( (CP - lowest)> (20 * Point))
{
if(Ticket < 20 )
{
currentlow = lowest;

//---Calculating resistance


R1 = lowest + (40 * Point);

OrderSelect(SellTicket,SELECT_BY_TICKET);

if(OrderCloseTime() == 0 && SellTicket > 0 && OrderType() == OP_SELLLIMIT)
{
Deleted = OrderDelete(SellTicket,Red);
}

else if( Bid < lowest)
{
Deleted = OrderDelete(SellTicket,Red);
}

if(StopLoss > 0) double SellStopLoss = R1 + (StopLoss * Point);
if(TakeProfit > 0) double SellTakeProfit = R1 -(TakeProfit * Point);

// Sell Order
ES = MathAbs((R1 - Ask));

if(Ask > R1 && ES >(20 * Point))
{
SellTicket = OrderSend(Symbol(),OP_SELLSTOP,LotSize,R1,UseSlippage,SellStopLoss,SellTakeProfit,"Sell Stop Order",MagicNumber,D+1,Red);
BuyTicket = 0;
}
else if(Ask < R1 && ES >(20 * Point))
{
SellTicket = OrderSend(Symbol(),OP_SELLLIMIT,LotSize,R1,UseSlippage,SellStopLoss,SellTakeProfit,"Sell Limit Order",MagicNumber,D+1,Red);
BuyTicket = 0;
}
}
}
return(0);
}

// Pip Point Function
double PipPoint(string Currency)
{
int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
if(CalcDigits == 2 || CalcDigits == 3) double CalcPoint = 0.01;
else if(CalcDigits == 4 || CalcDigits == 5) CalcPoint = 0.0001;
return(CalcPoint);
}

// Get Slippage Function
int GetSlippage(string Currency, int SlippagePips)
{
int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
if(CalcDigits == 2 || CalcDigits == 4) double CalcSlippage = SlippagePips;
else if(CalcDigits == 3 || CalcDigits == 5) CalcSlippage = SlippagePips * 10;
return(CalcSlippage);
}



